import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.StringTokenizer;

public class Main {
    private static StringTokenizer st;
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        int t = nextInt();
        for (int q = 0; q < t; q++) {
            long n = nextInt(), m = nextInt();
            long S = (n * m + 1L) * n * m / 2;
            long x, y;
            x:
            {
                long c = -S / n - n * (m - 1);
                long b = -1 + m * (n - 1);
                long d_ = (long) (Math.sqrt(b * b - 4 * c));
                long x1 = (-b + d_) / 2;
                long x2 = (-b + d_) / 2 + 1;
                if (sv(S, n, m, x1) <= sv(S, n, m, x2)) {
                    x = x1;
                } else x = x2;
            }
            y:
            {
                long d_ = (long) Math.sqrt(1 + 4 * S);
                long y1 = (-1 + d_) / 2 / m + 1;
                long y2 = (-1 + d_) / 2 / m + 1 + 1;
                if (sh(S, n, m, y1) <= sh(S, n, m, y2)) {
                    y = y1;
                } else y = y2;
            }
            if (sv(S, n, m, x) <= sh(S, n, m, y)) {
                System.out.println("V " + x);
                //System.out.println(sv(S, n, m, x - 1) + " " + sv(S, n, m, x) + " " + sv(S, n, m, x + 1));
            } else System.out.println("H " + y);
        }
    }

    private static long sv(long S, long n, long m, long x) {
        BigInteger N = new BigInteger(Long.toString(n));
        BigInteger M = new BigInteger(Long.toString(m));
        BigInteger X = new BigInteger(Long.toString(x));
        BigInteger s = N.multiply(X).multiply(X.subtract(BigInteger.ONE));
        s = s.add((N.subtract(BigInteger.ONE)).multiply(N).multiply(M).multiply(X.subtract(BigInteger.ONE)));
        return (s.subtract(new BigInteger(Long.toString(S))).abs().longValue());
        //return Math.abs(S - (n * (x - 1) * x + (n - 1) * n * m * (x - 1)));
    }

    private static long sh(long S, long n, long m, long y) {
        return Math.abs(S - ((y - 1) * m + 1) * (y - 1) * m);
    }
}
/*
5
1 3
4 7
1 10
3 3
3 5

 */