import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class Main {
    private static StringTokenizer st;
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        int t = nextInt();
        for (int q = 0; q < t; q++) {
            int n = nextInt(), m = nextInt();
            long S = (n * m + 1L) * n * m / 2;
            int x, y;
            x:
            {
                long c = -S / n - n * (m - 1);
                int b = -1 + m * (n - 1);
                int d_ = (int) (Math.sqrt(b * b - 4 * c));
                int x1 = (-b + d_) / 2;
                int x2 = (-b + d_ + 1) / 2;
                if (Math.abs(S / 2 - sv(n, m, x1)) <= Math.abs(S / 2 - sv(n, m, x2))) {
                    x = x1;
                } else x = x2;
            }
            y:
            {
                int d_ = (int) Math.sqrt(1 + 4 * S);
                int y1 = (-1 + d_) / 2 / m + 1;
                int y2 = (-1 + d_ + 1) / 2 / m + 1;
                if (Math.abs(S / 2 - sh(n, m, y1)) <= Math.abs(S / 2 - sh(n, m, y2))) {
                    y = y1;
                } else y = y2;
            }
            if (Math.abs(S / 2 - sv(n, m, x)) <= Math.abs(S / 2 - sh(n, m, y))) {
                System.out.println("V " + x);
            } else System.out.println("H " + y);
        }
    }

    private static long sv(int n, int m, int x) {
        return (long) n * (x - 1) * x / 2 + (long) (n - 1) * n / 2 * m * (x - 1);
    }

    private static long sh(int n, int m, int y) {
        return ((long) (y - 1) * m + 1) * (long) (y - 1) * m / 2;
    }
}
/*
5
1 3
4 7
1 10
3 3
3 5

 */