import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class C_ {
    private static StringTokenizer st;
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    private static class Pair {
        int k;
        char v;

        public Pair(int k, char v) {
            this.k = k;
            this.v = v;
        }

        int length(int x) {
            int y = k + x;
            if (y == 0) return 0;
            if (y == 1) return 1;
            return (int) Math.log10(y) + 2;
        }
    }

    public static void main(String[] args) throws IOException {
        String s = next();
        LinkedList<Pair> genes = new LinkedList<>();
        int x = 0;
        for (int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            if (c >= '0' && c <= '9') {
                x = x * 10 + c - '0';
            } else {
                if (x == 0) x = 1;
                genes.addLast(new Pair(x, c));
                x = 0;
            }
        }
        int m = genes.size();
        Pair[] arr = new Pair[m];
        for (int i = 0; i < m; i++) arr[i] = genes.removeFirst();
        int[] len = new int[m];
        int[] len_full = new int[m];
        len[0] = arr[0].length(0);
        len_full[0] = arr[0].k;
        for (int i = 1; i < m; i++) {
            len[i] = len[i - 1] + arr[i].length(0);
            len_full[i] = len_full[i - 1] + arr[i].k;
        }
        int[] len_min = new int[m];
        int[] x_min = new int[m];
        int[] d_min = new int[m];
        int[] c_min = new int[m];
        len_min[0] = arr[0].length(-1);
        x_min[0] = 0;
        d_min[0] = 2;
        c_min[0] = 'A'; // похуй
        for (int i = 1; i < m; i++) {
            int asdf = len[i - 1] + arr[i].length(-1);
            if (asdf >= len_min[i - 1] + arr[i].length(0)) {
                len_min[i] = len_min[i - 1] + arr[i].length(0);
                x_min[i] = x_min[i - 1];
                d_min[i] = d_min[i - 1];
                c_min[i] = c_min[i - 1];
            } else {
                len_min[i] = asdf;
                x_min[i] = len_full[i - 1];
                d_min[i] = 2;
                c_min[i] = 'A'; // похуй
            }
            if (i > 1) {
                if (arr[i - 2].v == arr[i].v && arr[i - 1].length(0) == 1) {
                    int prev_len = 0;
                    if (i >= 3) prev_len = len[i - 3];
                    int merged_len = arr[i - 2].length(arr[i].k);
                    if (merged_len + prev_len >= len_min[i - 1] + arr[0].length(0)) {
                        len_min[i] = len_min[i - 1] + arr[i].length(0);
                        x_min[i] = x_min[i - 1];
                        d_min[i] = d_min[i - 1];
                        c_min[i] = c_min[i - 1];
                    } else {
                        len_min[i] = merged_len + prev_len;
                        x_min[i] = len_full[i - 2];
                        d_min[i] = 2;
                        c_min[i] = 'A'; // похуй
                    }
                }
            }
        }

        int[] len_max = new int[m];
        int[] x_max = new int[m];
        int[] d_max = new int[m];
        int[] c_max = new int[m];
        len_max[0] = 1 + arr[0].length(0);
        x_max[0] = 0;
        d_max[0] = 1;
        char cmax = 'A';
        if (arr[0].v == cmax) cmax = 'C';
        c_max[0] = cmax;

        if (arr[0].k > 1) {
            int a = arr[0].k;
            int GHJK = arr[0].length(-suka(a)) + arr[0].length(-(a - suka(a))) + 1;
            if (GHJK > arr[0].length(0) && GHJK > len_max[0]) {
                len_max[0] = GHJK;
                d_max[0] = 1;
                x_max[0] = suka(a);
                cmax = 'A';
                if (cmax == arr[0].v) cmax = 'C';

                c_max[0] = cmax;
            }
        }

        for (int i = 1; i < m; i++) {
            int asdf = len[i - 1] + arr[i].length(0) + 1;
            if (asdf <= len_max[i - 1] + arr[i].length(0)) {
                len_max[i] = len_max[i - 1] + arr[0].length(0);
                d_max[i] = d_max[i - 1];
                x_max[i] = x_max[i - 1];
                c_max[i] = c_max[i - 1];
            } else {
                len_max[i] = len[i - 1] + arr[i].length(0) + 1;
                d_max[i] = 1;
                x_max[i] = len_full[i - 1];
                cmax = 'A';
                if (cmax == arr[i - 1].v || cmax == arr[i].v) cmax = 'C';
                if (cmax == arr[i - 1].v || cmax == arr[i].v) cmax = 'G';
                c_max[i] = cmax;
            }
            if (arr[i].k > 1) {
                int a = arr[i].k;
                int ghjk = len[i - 1] + arr[i].length(-suka(a)) + arr[i].length(-(a - suka(a))) + 1;
                if (ghjk > len_max[i - 1] + arr[i].length(0) && ghjk > len_max[i]) {
                    len_max[i] = ghjk;
                    d_max[i] = 1;
                    x_max[i] = len_full[i - 1] + suka(a);
                    cmax = 'A';
                    if (cmax == arr[i - 1].v || cmax == arr[i].v) cmax = 'C';
                    if (cmax == arr[i - 1].v || cmax == arr[i].v) cmax = 'G';
                    c_max[i] = cmax;
                } else {
                    len_max[i] = len_max[i - 1] + arr[0].length(0);
                    d_max[i] = d_max[i - 1];
                    x_max[i] = x_max[i - 1];
                    c_max[i] = c_max[i - 1];
                }
            }
        }

        System.out.println(d_min[m - 1] + " " + (x_min[m - 1] + 1));
        System.out.println(d_max[m - 1] + " " + (x_max[m - 1]) + " " + (char) c_max[m - 1]);
    }

    private static int suka(int x) {
        int log = (int) Math.log10(x), plog = (int) Math.pow(10, log);
        if (x <= 10 || plog == x) return x / 2;
        else return plog;
    }
}
//5AC5A2C
