import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class B_ {
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st = null;

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public static void main(String[] args) throws IOException {
        long x = nextLong(), k = nextLong();
        String s = Long.toString(x);
        if (k == 0) {
            System.out.println(find0(s));
        } else {
            int len = s.length();
            String f = find0(s), ans = f;

            for (int i = 0; i < len; i++) {
                String s1 = s.substring(0, i);
                String s2 = s.substring(i + 1);
                for (int m = 0; m <= 9; m++) {
                    String h = f.substring(0, i) + (char) ('0' + m) + f.substring(i + 1);
                    if (compare0(ans, h) > 0 && compare0(h, s) >= 0) ans = h;
                }
                String l = find0(s1 + s2);
                l = l.substring(0, i) + s.charAt(i) + l.substring(i);
                if (compare0(ans, l) > 0 && compare0(l, s) >= 0) ans = l;

            }
            System.out.println(ans);
        }
    }

    private static String find0(String s) {
        if (s.equals("")) return s;
        if (Long.parseLong(s) == 0) return s;
        int len = s.length();
        String[] arr = new String[(len + 1) * 9];
        int n = (len + 1) * 9;
        for (int i = 0; i < 9; i++) {
            arr[i] = Integer.toString(i + 1);
        }
        for (int i = 1; i <= len; i++) {
            for (int j = 0; j < 9; j++) {
                arr[i * 9 + j] = arr[(i - 1) * 9 + j] + arr[j];
            }
        }
        int l = -1, r = n - 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (compare0(s, arr[m]) > 0) l = m;
            else r = m;
        }
        return arr[r];
    }

    private static int compare0(String s, String t) {
        if (s.length() != t.length()) return Integer.compare(s.length(), t.length());
        return s.compareTo(t);
    }
}
