import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class C_ {
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    private static StringTokenizer st = null;

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws Exception {
        int n = nextInt(), m = nextInt(), c = nextInt();
        try {
            if (c == 2) {
                if (n <= 2 || m <= 2) {
                    for (int i = 0; i < n; i++) {
                        for (int j = 0; j < m; j++) {
                            System.out.print(1 + (i + j) % 2 + " ");
                        }
                        System.out.println();
                    }
                } else if (m <= 4) {
                    int[] a = new int[]{0b0011, 0b1100, 0b1001, 0b0110, 0b1010, 0b0101};
                    for (int i = 0; i < n; i++) {
                        for (int j = 0; j < m; j++) {
                            System.out.print(1 + ((a[i] >> j) & 1) + " ");
                        }
                        System.out.println();
                    }
                } else if (n <= 4) {
                    int[] a = new int[]{0b0011, 0b1100, 0b1001, 0b0110, 0b1010, 0b0101};
                    for (int i = 0; i < n; i++) {
                        for (int j = 0; j < m; j++) {
                            System.out.print(1 + ((a[j] >> i) & 1) + " ");
                        }
                        System.out.println();
                    }
                }
            } else {
                int[][] yoba = new int[][]{
                        {1, 1, 2, 2, 3, 3},
                        {3, 1, 1, 2, 2, 3},
                        {3, 3, 1, 1, 2, 2},
                        {2, 3, 3, 1, 1, 2},
                        {2, 2, 3, 3, 1, 1},
                        {1, 2, 2, 3, 3, 1},
                        {1, 2, 3, 1, 2, 3},
                        {3, 1, 2, 3, 1, 2},
                        {2, 3, 1, 2, 3, 1},
                };
                if (n <= 3 || m <= 3) {
                    for (int i = 0; i < n; i++) {
                        for (int j = 0; j < m; j++) {
                            System.out.print(1 + (i + j) % 3 + " ");
                        }
                        System.out.println();
                    }
                } else if (Math.min(n, m) <= 6 && Math.max(n, m) <= 9) {
                    if (n > m) {
                        for (int i = 0; i < n; i++) {
                            for (int j = 0; j < m; j++) {
                                System.out.print(yoba[i][j] + " ");
                            }
                            System.out.println();
                        }
                    } else {
                        for (int i = 0; i < n; i++) {
                            for (int j = 0; j < m; j++) {
                                System.out.print(yoba[j][i] + " ");
                            }
                            System.out.println();
                        }
                    }
                } else if (Math.min(n, m) <= 5 && Math.max(n, m) <= 10) {
                    int[][] obya = new int[][]{
                            {3, 1, 1, 2, 2},
                            {2, 3, 1, 1, 2},
                            {2, 2, 3, 1, 1},
                            {1, 2, 2, 3, 1},
                            {1, 1, 2, 2, 3},
                            {1, 2, 1, 2, 3},
                            {3, 1, 2, 1, 2},
                            {2, 3, 1, 2, 1},
                            {1, 2, 3, 1, 2},
                            {2, 1, 2, 3, 1},
                    };
                    if (n > m) {
                        for (int i = 0; i < n; i++) {
                            for (int j = 0; j < m; j++) {
                                System.out.print(obya[i][j] + " ");
                            }
                            System.out.println();
                        }
                    } else {
                        for (int i = 0; i < n; i++) {
                            for (int j = 0; j < m; j++) {
                                System.out.print(obya[j][i] + " ");
                            }
                            System.out.println();
                        }
                    }
                } else if (n == 9 && m == 9) {
                    int[][] aboy = new int[][]{
                            {1, 2, 3, 1, 2, 3, 1, 2, 3},
                            {3, 1, 2, 3, 1, 2, 3, 1, 2},
                            {2, 3, 1, 2, 3, 1, 2, 3, 1},
                            {1, 3, 1, 2, 1, 2, 3, 2, 3},
                            {3, 1, 3, 1, 2, 1, 2, 3, 2},
                            {2, 3, 1, 3, 1, 2, 1, 2, 3},
                            {1, 1, 3, 2, 2, 1, 3, 3, 2},
                            {2, 1, 1, 3, 2, 2, 1, 3, 3},
                            {3, 2, 1, 1, 3, 2, 2, 1, 3},
                    };
                    if (n > m) {
                        for (int i = 0; i < n; i++) {
                            for (int j = 0; j < m; j++) {
                                System.out.print(aboy[i][j] + " ");
                            }
                            System.out.println();
                        }
                    } else {
                        for (int i = 0; i < n; i++) {
                            for (int j = 0; j < m; j++) {
                                System.out.print(aboy[j][i] + " ");
                            }
                            System.out.println();
                        }
                    }
                    throw new Exception(":(");

                }
            }
        } catch (ArrayIndexOutOfBoundsException exc) {
            System.out.println(":(");
        }
    }
}
